#! /bin/bash

PACKAGE_NAME="printer-driver-bisheng-kyocera-fs-1100-kx"
PACKAGE_VERSION="2.0.1"
PRINTER_NAME=( "Kyocera FS-1100 KX" "Kyocera FS-1300D KX" "Kyocera KM-2540 KX" "Kyocera CS-2540 KX" "Kyocera KM-3040 KX" "Kyocera CS-3040 KX" "Kyocera KM-2560 KX" "Kyocera CS-2560 KX" "Kyocera KM-3060 KX" "Kyocera CS-3060 KX" "Kyocera FS-820 KX" "Kyocera FS-920 KX" "Kyocera FS-1118MFP KX" "Kyocera KM-1820 KX" "Kyocera CS-1820 KX" "Kyocera FS-1030D KX" "Kyocera FS-2000D KX" "Kyocera FS-3900DN KX" "Kyocera FS-4000DN KX" "Kyocera FS-6950DN KX" "Kyocera FS-9130DN KX" "Kyocera FS-9530DN KX" "Kyocera FS-C5015N KX" "Kyocera FS-C5020N KX" "Kyocera FS-C5025N KX" "Kyocera FS-C5030N KX" "Kyocera FS-C8100DN KX" "Kyocera KM-3050 KX" "Kyocera CS-3050 KX" "Kyocera KM-4050 KX" "Kyocera CS-4050 KX" "Kyocera KM-5050 KX" "Kyocera CS-5050 KX" "Kyocera KM-6030 KX" "Kyocera CS-6030 KX" "Kyocera KM-8030 KX" "Kyocera CS-8030 KX" "Kyocera KM-C2520 KX" "Kyocera CS-C2520 KX" "Kyocera KM-C3225 KX" "Kyocera CS-C3225 KX" "Kyocera KM-C3232 KX" "Kyocera CS-C3232 KX" "Kyocera KM-C4008 KX" "Kyocera CS-C4008 KX" "Kyocera KM-C4035E KX" "Kyocera CS-C4035E KX" "Kyocera KM-C3232E KX" "Kyocera CS-C3232E KX" "Kyocera KM-C3225E KX" "Kyocera CS-C3225E KX" "Kyocera KM-C2525E KX" "Kyocera CS-C2525E KX" "Kyocera Generic mono KX" "Kyocera Generic color KX" "Kyocera Mita CS-1650 KX" "Kyocera Mita KM-1650 KX" "Kyocera Mita CS-1815 KX" "Kyocera Mita FS-1018MFP KX" "Kyocera Mita KM-1815 KX" "Kyocera Mita CS-2050 KX" "Kyocera Mita KM-2050 KX" "Kyocera Mita CS-2550 KX" "Kyocera Mita KM-2550 KX" "Kyocera Mita FS-1010 KX" "Kyocera Mita FS-1020D KX" "Kyocera Mita FS-1050 KX" "Kyocera Mita FS-1800 KX" "Kyocera Mita FS-1800+ KX" "Kyocera Mita FS-1900 KX" "Kyocera Mita FS-1920 KX" "Kyocera Mita FS-3800 KX" "Kyocera Mita FS-3800KPDL3 KX" "Kyocera Mita FS-3820N KX" "Kyocera Mita FS-3830N KX" "Kyocera Mita FS-C5016N KX" "Kyocera Mita FS-6020 KX" "Kyocera Mita FS-6026 KX" "Kyocera Mita FS-C8008N KX" "Kyocera Mita FS-C8026N KX" "Kyocera Mita FS-9100DN KX" "Kyocera Mita FS-9120DN KX" "Kyocera Mita FS-9500DN KX" "Kyocera Mita FS-9520DN KX" "Kyocera Mita KM-1530 KX" "Kyocera Mita KM-2030 KX" "Kyocera Mita KM-2530 KX" "Kyocera Mita KM-3035 KX" "Kyocera Mita KM-3530 KX" "Kyocera Mita KM-4030 KX" "Kyocera Mita KM-4035 KX" "Kyocera Mita KM-4530 KX" "Kyocera Mita KM-5035 KX" "Kyocera Mita KM-5530 KX" "Kyocera Mita KM-6330 KX" "Kyocera Mita KM-7530 KX" "Kyocera Mita KM-C830 KX" "Kyocera Mita KM-C850 KX" "Kyocera Mita KM-C2630 KX" "Kyocera FS-2020D KX" "Kyocera FS-3920DN KX" "Kyocera FS-4020DN KX" "Kyocera FS-6970DN KX" "Kyocera FS-C5100DN KX" "Kyocera FS-C5200DN KX" "Kyocera FS-C5300DN KX" "Kyocera FS-C5350DN KX" "Kyocera FS-C5400DN KX" "Kyocera FS-1350DN KX" "Kyocera FS-C8100DN+ KX" "Kyocera TASKalfa 500ci KX" "Kyocera CS 500ci KX" "Kyocera TASKalfa 400ci KX" "Kyocera CS 400ci KX" "Kyocera TASKalfa 300ci KX" "Kyocera CS 300ci KX" "Kyocera TASKalfa 250ci KX" "Kyocera CS 250ci KX" "Kyocera TASKalfa 620 KX" "Kyocera CS 620 KX" "Kyocera TASKalfa 820 KX" "Kyocera CS 820 KX" "Kyocera TASKalfa 181 KX" "Kyocera CS 181 KX" "Kyocera TASKalfa 221 KX" "Kyocera CS 221 KX" "Kyocera FS-1028MFP KX" "Kyocera FS-1128MFP KX" "Kyocera KM-2810 KX" "Kyocera KM-2820 KX" "Kyocera CS 300i KX" "Kyocera TASKalfa 300i KX" "Kyocera FS-C8500DN KX" "Kyocera CS 552ci KX" "Kyocera TASKalfa 552ci KX" "Kyocera TASKalfa 420i KX" "Kyocera CS 420i KX" "Kyocera TASKalfa 520i KX" "Kyocera CS 520i KX" "Kyocera FS-6975DN KX" "Kyocera FS-2025D KX" "Kyocera FS-3925DN KX" "Kyocera FS-4025DN KX" "Kyocera FS-1120D KX" "Kyocera FS-1320D KX" "Kyocera FS-1370DN KX" "Kyocera FS-3040MFP KX" "Kyocera FS-3140MFP KX" "Kyocera FS-C2026MFP KX" "Kyocera FS-C2126MFP KX" "Kyocera FS-C5150DN KX" "Kyocera FS-C5250DN KX" "Kyocera TASKalfa 3050ci KX" "Kyocera CS 3050ci KX" "Kyocera TASKalfa 3550ci KX" "Kyocera CS 3550ci KX" "Kyocera TASKalfa 4550ci KX" "Kyocera CS 4550ci KX" "Kyocera TASKalfa 5550ci KX" "Kyocera CS 5550ci KX" "Kyocera TASKalfa 6550ci KX" "Kyocera CS 6550ci KX" "Kyocera TASKalfa 7550ci KX" "Kyocera CS 7550ci KX" "Kyocera TASKalfa 3500i KX" "Kyocera CS 3500i KX" "Kyocera TASKalfa 4500i KX" "Kyocera CS 4500i KX" "Kyocera TASKalfa 5500i KX" "Kyocera CS 5500i KX" "Kyocera TASKalfa 6500i KX" "Kyocera CS 6500i KX" "Kyocera TASKalfa 8000i KX" "Kyocera CS 8000i KX" "Kyocera CS 205c KX" "Kyocera FS-C8020MFP KX" "Kyocera TASKalfa 205c KX" "Kyocera CS 255c KX" "Kyocera FS-C8025MFP KX" "Kyocera TASKalfa 255c KX" "Kyocera CS 255 KX" "Kyocera FS-6025MFP KX" "Kyocera TASKalfa 255 KX" "Kyocera CS 305 KX" "Kyocera FS-6030MFP KX" "Kyocera TASKalfa 305 KX" "Kyocera FS-C2526MFP KX" "Kyocera FS-C2626MFP KX" "Kyocera FS-3540MFP KX" "Kyocera FS-3640MFP KX" "Kyocera FS-C2026MFP+ KX" "Kyocera FS-C2126MFP+ KX" "Kyocera FS-3040MFP+ KX" "Kyocera FS-3140MFP+ KX" "Kyocera FS-1024MFP KX" "Kyocera FS-1124MFP KX" "Kyocera FS-1110 KX" "Kyocera FS-1030MFP KX" "Kyocera FS-1130MFP KX" "Kyocera FS-1035MFP KX" "Kyocera FS-1135MFP KX" "Kyocera TASKalfa 2550ci KX" "Kyocera CS 2550ci KX" "Kyocera FS-6525MFP KX" "Kyocera FS-6530MFP KX" "Kyocera FS-C8520MFP KX" "Kyocera FS-C8525MFP KX" "Kyocera FS-C8650DN KX" "Kyocera FS-C8600DN KX" "Kyocera FS-4300DN KX" "Kyocera FS-4200DN KX" "Kyocera FS-4100DN KX" "Kyocera FS-2100DN KX" "Kyocera FS-2100D KX" "Kyocera TASKalfa 265ci KX" "Kyocera TASKalfa 3051ci KX" "Kyocera CS 3051ci KX" "Kyocera TASKalfa 3551ci KX" "Kyocera CS 3551ci KX" "Kyocera TASKalfa 4551ci KX" "Kyocera CS 4551ci KX" "Kyocera TASKalfa 5551ci KX" "Kyocera CS 5551ci KX" "Kyocera TASKalfa 6551ci KX" "Kyocera CS 6551ci KX" "Kyocera TASKalfa 7551ci KX" "Kyocera CS 7551ci KX" "Kyocera TASKalfa 3501i KX" "Kyocera CS 3501i KX" "Kyocera TASKalfa 4501i KX" "Kyocera CS 4501i KX" "Kyocera TASKalfa 5501i KX" "Kyocera CS 5501i KX" "Kyocera TASKalfa 6501i KX" "Kyocera CS 6501i KX" "Kyocera TASKalfa 8001i KX" "Kyocera CS 8001i KX" "Kyocera TASKalfa 2551ci KX" "Kyocera CS 2551ci KX" "Kyocera TASKalfa 3510i KX" "Kyocera CS 3510i KX" "Kyocera TASKalfa 3010i KX" "Kyocera CS 3010i KX" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
WINEBIN="bisheng"
REGDIR="reg"
FILEDIR="files"

PRINTER_C=$1
found=0
for name in "${PRINTER_NAME[@]}"; do
    if [ "$PRINTER_C" = "$name" ]; then
        found=1
        break
    fi
done

if [ $found -eq 0 ]; then
    echo "printer $PRINTER_C not found"
    exit 0
fi

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        rm -rf "$CONTAINER_PATH"
    fi
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f  $WININI ]; then
    grep -q "^$PRINTER_C=winerp.drv,USB" "$WININI" && exit 0
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

if [ -f "$WININI" ]; then
    grep -q "^\[devices\]" "$WININI" || sed -i -e "$ a [devices]" "$WININI"
    grep -q "^\[PrinterPorts\]" "$WININI" || sed -i -e "$ a [PrinterPorts]" "$WININI"
    sed -i -e "/^\[devices\]/a $PRINTER_C=winerp.drv,USB" "$WININI"
    sed -i -e "/^\[PrinterPorts\]/a $PRINTER_C=winerp.drv,USB,15,45" "$WININI"
fi

WINESERVER_RUNNING=1
WINESERVER_FINDNUM=0
while [ $WINESERVER_RUNNING -eq 1 ]
do
        WINESERVER_PATH=`ps -aux|grep wineserver|grep -v grep`
        if [ "$WINESERVER_PATH" = "" ] || [ $WINESERVER_FINDNUM -eq 3 ]; then
                WINESERVER_RUNNING=0
        else
                let WINESERVER_FINDNUM+=1
                sleep 1
        fi
done

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
echo "$PRINTER_NAME" > "$CONTAINER_PATH/name.log"
